#include <conio.h>
#include <iostream.h>
#include <time.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include "myio.h"
#include "cgdlogo.h"

const int ACTION = 0, WEAPON = 1, ARMOR = 2, SPELL = 3, EQUIPMENT = 4, RING = 5;
const int MALE = 0, FEMALE = 1, X = 0, Y = 1;
const int MUP = 1, MDOWN = 2, MRIGHT = 3, MLEFT = 4, RHAND = 5, LHAND = 6, MENU = 7, DROP = 8;
//door contants
const int NOWALL = 0, WOOD = 10, STONE = 20, GRATE = 30, STEEL = 40, SOLID = 50;
const int OPEN = 0, SECRET = 1, EASY = 2, HARD = 4, LOCKED = 4;
//torch constants
const int NOTORCH = 0, UNLIT = 1, LIT = 2;
//curse constants
const char NONE = 0, EWC = 1, WOWC = 2, ASFC = 4, FATC = 8, IFC = 16, FLC = 32;
//eternal wound, weight of world, aim shall fail, foe's aim true, instill fear, fairy light
//monster constants
const int NORMAL = 0, GIANT = 1, WERE = 2, UNDEAD = 3, SKELETAL = 5, DARK = 6, YOUNG = 4, ICED = 7;
//floor constants
const int TILE = 0, CHEST = 10, TRAP = 20, TCHEST = 30, ITEM = 110, MONEY = 90, MAGIC = 100, CLEARH2O = 40, MUDDYH2O = 50, SOLIDWALL = 60, CRUMBWALL = 70, FIRE = 80;
const int PLAYER1 = 1, PLAYER2 = 2, PLAYER3 = 3, PLAYER4 = 4, STAND = 5, TASK = 6, FOLLOW1 = 7, FOLLOW2 = 8, FOLLOW3 = 9, FOLLOW4 = 10;
const int MAINX = 16, HANDX = 19, CURSEX = 26;
const int HPY = 1, MPY = 2, MONEYY = 3, WEIGHTY = 4, EXPERY = 5, RHANDY = 8, LHANDY = 9, FOUNDY = 6, CURSEY = 3;
const char UDHP = 1, UDMP = 2, UDMONEY = 4, UDWEIGHT = 8, UDEXPER = 16, UDHANDS = 32, UDFOUND = 64, UDCURSE = 128;

struct item
{
  char itemname[18];
  int cost, level, weight, iclass, instock;
  int reqattr, magic, pattern, special, expend;
};// itemlist[60];

struct player
{
  char playername[20], cursed;
  int money, level, sex, weight, hpcap, mpcap, experience, dead, playing;
  int strength, magic, stamina, guard, intelligence, luck, dexterity, charisma, morality;
  int inventory[60], number[60], items, oillight, torchlight, arrows[3];
};// character[8];

struct ingameplay
{
  char upd, indmap[10][10];
  int x, y, facing, moving, roomx, roomy, mx, my, mdx, mdy, inmenu, casting;
  int hit, foe, newright, newleft, newwear, dropping, itemfound, fx, fy;
  int control, view, rhand, lhand, wearing, inaction, hp, mp, rd, lanlit, torchlit;
  int ring, newring, hasmap;
};// pc[4];

struct monster
{
  char monstername[20];
  int type, hpcap, brains, level, speed;
};// monsters[6];

struct ingamemon
{
  int hp, x, y, hit, target;
  char cursed;
};// mon[4][10];

struct room
{
  int monsters, traps, chests, goodies, torch, mtindex, flooded, fire, walls;
  monster *monstertype;
};// map[10][10];

struct projectile
{
  int x, y, moving, level, lifespan, special, who, rd, color, frames[4];
};// shots[36];


struct keys
{
  int up, down, left, right, rhand, lhand, menu, drop;
};// playkeys[2];

void addplayer(void);
void modplayer(int a = -1);
void viewplayer(int a= -1);
void buyitems(void);
void purchase(int selection[20], int itemsforsale, int a);
void sellitems(void);
int additem(int p, int i);
int removeitem(int p, int i);
void createdungeon(void);
void createmonsters(void);
void createitems(void);
void createroom(int ch, int rx, int ry);
void playgame(void);
void humancon(int ckey, int charac);
void checkchest(int rd, int edx, int edy, int ex, int ey, int lev);
void checkdoor(int *thedoor, int ex, int ey, int x, int y, int ch, int hit = -1);
void trydoor(int *thedoor, int ex, int ey, int ch, int hit = 0);
void useitem(int touse, int ohand, int u, int whand);
void findfree(int (*pro)[9], int howmany);
void sc(int p, int x, int y, int m, int l, int life, int s, int w, int r, int col, int f1, int f2, int f3, int f4);
void makegoody(int rd, int gx, int gy);
int savegame(void);
int loadgame(void);
void definekeys(void);
void namebar(void);
void update(int wx, int wy, int v);
void gdoor(int wall, int ch);
void defplayer(int pl);
void chmenu(int ch, int sndst);
void killplayer(int ch);
int attacknear(int ch);
int seek(int ch, int tx, int ty);
int task(int ch);
int follow(int ch);
void shift(int ch, int i);
void maproom(int mx, int my, char *theroom);
int quicksave(void);
int quickload(void);
void getpass(void);
void sc2(int ch);
void stickkey(int (*keybuf)[10], int ch);
int pullkey(int (*keybuf)[10]);
void sellstuff(int a);
void pausescr(int sndst);
void soundtest(void);
void saveonechar(void);
void loadonechar(void);