#include "dungame.h"

extern char dungeonname[30];
extern int doors[11][21], floor[4][10][10], depth, c[4], rdu[4], players;
extern int doorx[4], doory[4], startx, starty, mysticx, mysticy, rooms[4][2];
extern char walls[4][10], gwall[4][4][10][2];
extern char bits[8];
extern char controls[6][9];
extern char classes[12][12];
extern sndsys snd;
extern int sb[10];
extern int ssilence[10];
extern int sblank[10];
extern int scurse[10];
extern int scure[10];
extern int sswish[10];
extern int sfind[10];
extern int smagic[10];
extern int smonhit[10];
extern int splayhit[10];
extern int sheal[10];
extern int swind[10];
extern int sboom[10];
extern int sbolt[10];
extern int slight[10];
extern int sdead[10];
extern int sdrop[10];

extern char gmap[16];
extern char themap[10][10], password[41];
extern int quicksaved, characters;

extern item itemlist[60];
extern player character[8];
extern ingameplay pc[4];
extern monster monsters[6];
extern ingamemon mon[4][10];
extern room map[10][10];
extern projectile shots[36];
extern keys playkeys[2];

void stickkey(int (*keybuf)[10], int ch)
{
  for (int a = 0;a < 10;a++)
  {
    if ((*keybuf)[a] == 0)
    {
      (*keybuf)[a] = ch;
      break;
    }
  }
  if (a == 10)
  {
    pullkey(keybuf);
    (*keybuf)[9] = ch;
  }
}

int pullkey(int (*keybuf)[10])
{
  int b = (*keybuf)[0];
  for (int a = 0;a < 9;a++)
    (*keybuf)[a] = (*keybuf)[a+1];
  (*keybuf)[9] = 0;
  return b;
}

void defplayer(int pl)
{
  int x, y;
  switch (pl)
  {
    case 0: x = 5;
            y = 4;
            break;
    case 1: x = 4;
            y = 3;
            break;
    case 2: x = 4;
            y = 5;
            break;
    case 3: x = 3;
            y = 5;
            break;
  }
  pc[pl].upd = NONE;
  pc[pl].x = x;
  pc[pl].y = y;
  pc[pl].facing = MRIGHT;
  pc[pl].moving = NONE;
  pc[pl].roomx = startx;
  pc[pl].roomy = starty;
  pc[pl].inmenu = -1;
  pc[pl].casting = 0;
  pc[pl].hit = 0;
  pc[pl].foe = 0;
  pc[pl].newright = 0;
  pc[pl].newleft = 1;
  pc[pl].newwear = 0;
  pc[pl].itemfound = 0;
  pc[pl].fx = x;
  pc[pl].fy = y;
  pc[pl].control = PLAYER1;
  pc[pl].view = NONE;
  y = 0;
  for (x = 0;x < 4;x++)
  {
    if (pc[x].view == PLAYER1)
    {
      y = 1;
      break;
    }
  }
  if (y == 0)
    pc[pl].view = PLAYER1;
  else
  {
    y = 0;
    for (x = 0;x < 4;x++)
    {
      if (pc[x].view == PLAYER2)
      {
        y = 1;
        break;
      }
    }
    if (y == 0)
      pc[pl].view = PLAYER2;
  }
  pc[pl].rhand = 0;
  pc[pl].lhand = 1;
  pc[pl].wearing = 0;
  pc[pl].inaction = 0;
  pc[pl].hp = character[c[pl]].hpcap;
  pc[pl].mp = character[c[pl]].mpcap;
  pc[pl].rd = -1;
  for (x = 0;x < 4;x++)
  {
    if (pc[x].roomx == startx && pc[x].roomy == starty && x != pl && c[x] != -1)
    {
      pc[pl].rd = pc[x].rd;
      rdu[pc[x].rd]++;
      break;
    }
  }
  if (pc[pl].rd == -1)
  {
    for (x = 0;x < 4;x++)
    {
      if (rdu[x] == 0)
      {
        pc[pl].rd = x;
        rdu[x] = 1;
        createroom(pl, startx, starty);
        break;
      }
    }
  }
  pc[pl].lanlit = UNLIT;
  pc[pl].torchlit = UNLIT;
  pc[pl].ring = 0;
  pc[pl].newring = 0;
  pc[pl].hasmap = 0;
  character[c[pl]].playing = 1;
}

void sellstuff(int a)
{
  int b, d;
      for (b = 6;b < 30;b++)
      {
        if (character[c[a]].inventory[b] == 57)
          break;
      }
      if (b < 30)
      {
        d = character[c[a]].number[b];
        while (d-- > 0)
        {
          character[c[a]].money += itemlist[57].cost;
          removeitem(c[a], b);
        }
        shift(a, b);
      }
      for (b = 6;b < 30;b++)
      {
        if (character[c[a]].inventory[b] == 38)
          break;
      }
      if (b < 30)
      {
        d = character[c[a]].number[b];
        while (d-- > 0)
        {
          character[c[a]].money += itemlist[38].cost;
          removeitem(c[a], b);
        }
        shift(a, b);
      }
}
void chmenu(int ch, int sndst)
{
  int cx = 10, ox = 0, a = 0, b, e;
  gotoxy(40, 10);
  cprintf("%s", controls[pc[ch].control-1]);
  gotoxy(35, 12);
  cputs("                  ");
  gotoxy(40, 11);
  cprintf("%c", pc[ch].view+48);
  do {
    if (cx < 10)
      cx = 15;
    else if (cx > 15)
      cx = 10;
    if (cx != ox)
    {
      gotoxy(28, ox);
      putch(32);
      gotoxy(28, cx);
      putch('>');
      ox = cx;
    }
    switch(getkey())
    {
      case UP: cx--; break;
      case DOWN: cx++; break;
      case SPACE: switch (cx)
                  {
                    case 10: b = 0;
                            do {
                              switch (getkey())
                              {
                                case LEFT: pc[ch].control--;
                                           if ((pc[ch].control < PLAYER1 && pc[ch].view != NONE) || (pc[ch].control < STAND && pc[ch].view == NONE))
                                             pc[ch].control = FOLLOW2;
                                           break;
                                case RIGHT: pc[ch].control++;
                                            if (pc[ch].control > FOLLOW2)
                                            {
                                              if (pc[ch].view != NONE)
                                                pc[ch].control = PLAYER1;
                                              else
                                                pc[ch].control = STAND;
                                            }
                                            break;
                                case SPACE: b = 1; break;
                              }
                              gotoxy(40, 10);
                              cprintf("%s", controls[pc[ch].control-1]);
                            } while (b == 0);
                            break;
                    case 11: b = 0;
                            do {
                              switch (getkey())
                              {
                                case LEFT: pc[ch].view--;
                                           if (pc[ch].view < NONE)
                                             pc[ch].view = PLAYER2;
                                           break;
                                case RIGHT: pc[ch].view++;
                                            if (pc[ch].view > PLAYER2)
                                              pc[ch].view = NONE;
                                            break;
                                case SPACE: b = 1; break;
                              }
                              gotoxy(40, 11);
                              cprintf("%c", pc[ch].view+48);
                            } while (b == 0);
                            break;
                    case 12: if (c[ch] != -1)
                             {
                               gotoxy(35, 12);
                               cputs("Slot taken");
                               break;
                             }
                             do {
                               gotoxy(35, 12);
                               cputs("          ");
                               gotoxy(35, 12);
                               cputs("Who? ");
                               cin >> c[ch];
                               for (b = 0;b < 4;b++)
                                 if (c[ch] == c[b] && ch != b)
                                   c[ch] = -1;
                             } while (c[ch] == -1);
                             defplayer(ch);
                             pc[ch].control = STAND;
                             players++;
                             gotoxy(40, 10);
                             cprintf("%s", controls[pc[ch].control-1]);
                             gotoxy(35, 12);
                             cputs("                  ");
                             gotoxy(40, 11);
                             cprintf("%c", pc[ch].view+48);
                             if (character[c[ch]].items == 6)
                             {
                               gotoxy(1, 20);
                               cputs("\"You wouldn't dare go down empty-handed, Would you?\"\r\n");
                               cputs("\"Here, please take a tinder box and torch.\"");
                               character[c[ch]].inventory[6] = 48;
                               character[c[ch]].number[6] = 1;
                               character[c[ch]].inventory[7] = 50;
                               character[c[ch]].number[7] = 1;
                               character[c[ch]].items = 8;
                               character[c[ch]].weight = 4;
                             }
                             break;
                    case 13: gotoxy(40, 13);
                             cputs("Are you sure?(y/n) ");
                             if (getch() == 'y')
                             {
                               character[c[ch]].playing = 0;
                               players--;
                               killplayer(ch);
                             }
                             break;
                    case 14: viewplayer(c[ch]);
                             pausescr(sndst);
                             ox = 13;
                             break;
                    case 15: gotoxy(28, cx);
                             putch(SPACE);
                             a = 1;
                             break;
                  }
                  break;
    }
  } while (a == 0);
}

void killplayer(int ch)
{
  int a, b;
  snd.copy(sdead);
  for (a = 0;a < 10;a++)
  {
    snd.play();
    delay(35);
    snd.pstop();
    delay(75);
  }
  snd.pstop(1);
  textattr(LIGHTGRAY + (BLACK << 4));
  gotoxy(20, 20);
  cprintf("Character #%d, %s, has died!               ", c[ch], character[c[ch]].playername);
  gotoxy(20, 21);
  cprintf("You will lose all posesions and ");
  gotoxy(20, 22);
  cprintf("money, but you can retain your");
  gotoxy(20, 23);
  cprintf("attributes by saving soul.");
  gotoxy(20, 24);
  cprintf("(K)ill them forever, or (s)ave soul? ");
  while (getkey() != 0)
    ;
  for (;;)
  {
    a = getch();
    if (a == 'k')
    {
      character[c[ch]].dead = 0;
      break;
    }
    else if (a == 's')
    {
      snd.copy(sfind, &sb);
      snd.copy(sb);
      for (b = 0;b < 10;b++)
      {
        snd.play();
        delay(35);
        snd.pstop();
        delay(75);
      }
      snd.pstop(1);
      character[c[ch]].money = 0;
      character[c[ch]].weight = 0;
      character[c[ch]].items = 6;
      character[c[ch]].cursed = NONE;
      character[c[ch]].oillight = 0;
      character[c[ch]].torchlight = 200;
      for (a = 0;a < 3;a++)
        character[c[ch]].arrows[a] = 10;
      for (a = 6;a < 30;a++)
      {
        character[c[ch]].inventory[a] = 100;
        character[c[ch]].number[a] = 0;
      }
      break;
    }
  }
  c[ch] = -1;
}

int attacknear(int ch)
{
  int a, b, d = NONE;
  b = itemlist[character[c[ch]].inventory[pc[ch].rhand]].pattern;
  for (a = 0;a < 10;a++)
  {
    if (mon[pc[ch].rd][a].hp > 0)
    {
    if (pc[ch].x == mon[pc[ch].rd][a].x && ((pc[ch].y - 1 == mon[pc[ch].rd][a].y && b == 1) || (b == 2 || b == 3)))
    {
      d = MUP;
      if (pc[ch].facing == d)
        d = RHAND;
    }
    if (pc[ch].x == mon[pc[ch].rd][a].x && ((pc[ch].y + 1 == mon[pc[ch].rd][a].y && b == 1) || (b == 2 || b == 3)))
    {
      d = MDOWN;
      if (pc[ch].facing == d)
        d = RHAND;
    }
    if (pc[ch].y == mon[pc[ch].rd][a].y && ((pc[ch].x - 1 == mon[pc[ch].rd][a].x && b == 1) || (b == 2 || b == 3)))
    {
      d = MLEFT;
      if (pc[ch].facing == d)
        d = RHAND;
    }
    if (pc[ch].y == mon[pc[ch].rd][a].y && ((pc[ch].x + 1 == mon[pc[ch].rd][a].x && b == 1) || (b == 2 || b == 3)))
    {
      d = MRIGHT;
      if (pc[ch].facing == d)
        d = RHAND;
    }
    if (d != NONE)
      break;
    }
  }
  return d;
}

int seek(int ch, int tx, int ty)
{
  int a, b = NONE, dx = 0, dy = 0;
  a = random(4);
  if (a == 0)
  {
    if (tx - pc[ch].x < 0)
      b = MLEFT;
    else if (tx - pc[ch].x > 0)
      b = MRIGHT;
  }
  else if (a == 1)
  {
    if (ty - pc[ch].y < 0)
      b = MUP;
    else if (ty - pc[ch].y > 0)
      b = MDOWN;
  }
  else
    b = pc[ch].facing;
  switch (b)
  {
    case MUP: dy = -1; break;
    case MDOWN: dy = 1; break;
    case MRIGHT: dx = 1; break;
    case MLEFT: dx = -1; break;
  }
  a = floor[pc[ch].rd][pc[ch].x + dx][pc[ch].y + dy];
  if (a == TRAP || a == TCHEST)
    b = NONE;
  return b;
}

int task(int ch)
{
  int a, b, d = NONE, gx = 0, gy = 0;
  a = character[c[ch]].inventory[pc[ch].rhand];
  if (a == 3 || a == 42)
  {
    if (pc[ch].x == 4 && pc[ch].y == 0)
      d = MUP;
    else if (pc[ch].x == 4 && pc[ch].y == 9)
      d = MDOWN;
    else if (pc[ch].x == 0 && pc[ch].y == 4)
      d = MLEFT;
    else if (pc[ch].x == 9 && pc[ch].y == 4)
      d = MRIGHT;
    if (d != NONE)
    {
      b = doors[pc[ch].roomx + doorx[d-1]][pc[ch].roomy * 2 + doory[d-1]];
      if (b % 2 == 1 || b % 10 == OPEN)
        d = RHAND;
    }
    else
      d = RHAND;
  }
  else if (a == 0 && map[pc[ch].roomx][pc[ch].roomy].monsters == 0)
  {
    b = 0;
    for (gx = 0;gx < 10;gx++)
    {
      for (gy = 0;gy < 10;gy ++)
      {
        if (floor[pc[ch].rd][gx][gy] == CHEST || (floor[pc[ch].rd][gx][gy] % 10  == TCHEST && floor[pc[ch].rd][gx][gy] != TCHEST))
        {
          b = 1;
          break;
        }
      }
      if (b == 1)
        break;
    }
    if (gx < 10 && gy < 10)
      d = seek(ch, gx, gy);
    else
    {
      b = 0;
      for (gx = 0;gx < 10;gx++)
      {
        for (gy = 0;gy < 10;gy ++)
        {
          if (floor[pc[ch].rd][gx][gy] >= MONEY)
          {
            b = 1;
            break;
          }
        }
        if (b == 1)
          break;
      }
      if (gx < 10 && gy < 10)
      {
        if (pc[ch].x - gx == 1 && pc[ch].y == gy)
        {
          if (pc[ch].facing == MLEFT)
            d = RHAND;
          else
            d = MLEFT;
        }
        if (pc[ch].x - gx == -1 && pc[ch].y == gy)
        {
          if (pc[ch].facing == MRIGHT)
            d = RHAND;
          else
            d = MRIGHT;
        }
        if (pc[ch].x == gx && pc[ch].y - gy == 1)
        {
          if (pc[ch].facing == MUP)
            d = RHAND;
          else
            d = MUP;
        }
        if (pc[ch].x == gx && pc[ch].y - gy == -1)
        {
          if (pc[ch].facing == MDOWN)
            d = RHAND;
          else
            d = MDOWN;
        }
        if (d == NONE)
          d = seek(ch, gx, gy);
      }
    }
  }
  else if (itemlist[a].pattern == 1 || itemlist[a].pattern == 2 || itemlist[a].pattern == 3)
  {
    d = attacknear(ch);
    if (d == NONE)
    {
      for (b = 0;b < 10;b++)
      {
        if (mon[pc[ch].rd][b].hp > 0)
        {
          d = seek(ch, mon[pc[ch].rd][b].x, mon[pc[ch].rd][b].y);
          break;
        }
      }
    }
  }
  return d;
}

int follow(int ch)
{
  int a, b, d = NONE;
  d = attacknear(ch);
  if (d == NONE)
  {
    (pc[ch].control == FOLLOW1) ? (b = PLAYER1) : (b = PLAYER2);
    for (a = 0;a < 4;a++)
    {
      if (pc[a].control == b)
        break;
    }
    if (pc[ch].roomx == pc[a].roomx && pc[ch].roomy == pc[a].roomy)
      d = seek(ch, pc[a].x, pc[a].y);
    else
    {
      if (pc[ch].roomx == pc[a].roomx)
      {
        if (pc[ch].roomy - pc[a].roomy == 1)
          d = seek(ch, 4, -1);
        else if (pc[ch].roomy - pc[a].roomy == -1)
          d = seek(ch, 4, 10);
      }
      if (pc[ch].roomy == pc[a].roomy)
      {
        if (pc[ch].roomx - pc[a].roomx == 1)
          d = seek(ch, -1, 4);
        else if (pc[ch].roomx - pc[a].roomx == -1)
          d = seek(ch, 10, 4);
      }
    }
  }
  return d;
}

void pausescr(int sndst)
{
  char on_off[2][4] = {{"Off"}, {"On "}};
                   clrscr();
                   gotoxy(30, 1);
                   cputs("Continue");
                   gotoxy(30, 2);
                   cputs("Quit");
                   gotoxy(30, 3);
                   cputs("Speed:");
                   gotoxy(30, 4);
                   cprintf("Sound: %s", on_off[sndst]);
                   gotoxy(29, 9);
                   cputs("----------------");
                   gotoxy(30, 10);
                   cputs("Control:");
                   gotoxy(30, 11);
                   cputs("Window:");
                   gotoxy(30, 12);
                   cputs("Add");
                   gotoxy(30, 13);
                   cputs("Remove");
                   gotoxy(30, 14);
                   cputs("View");
                   gotoxy(30, 15);
                   cputs("Done");
}

void maproom(int mx, int my, char *theroom)
{
  int a;
  if (*theroom < 16)
    *theroom = 0;
  else
    *theroom = 16;
  a = doors[mx + doorx[MUP-1]][my * 2 + doory[MUP-1]];
  if (a != SOLID && a % 2 != SECRET)
    *theroom += 1;
  a = doors[mx + doorx[MRIGHT-1]][my * 2 + doory[MRIGHT-1]];
  if (a != SOLID && a % 2 != SECRET)
    *theroom += 2;
  a = doors[mx + doorx[MDOWN-1]][my * 2 + doory[MDOWN-1]];
  if (a != SOLID && a % 2 != SECRET)
    *theroom += 4;
  a = doors[mx + doorx[MLEFT-1]][my * 2 + doory[MLEFT-1]];
  if (a != SOLID && a % 2 != SECRET)
    *theroom += 8;
}

void playgame(void)
{
  int gamespeed = 75, a, b, d, e, g, p1key, p2key, soundstat = 1;
  int frame = 0, cx, ox, dx, dy, projec[9], fire[5] = {RED, LIGHTRED, YELLOW, BROWN, WHITE};
  char scrbuf[24][12], f, light[2][4][2] = {
  {{WHITE + (LIGHTGRAY << 4), 177}, {WHITE + (LIGHTGRAY << 4), 176}, {WHITE + (LIGHTGRAY << 4), 176}, {WHITE + (BROWN << 4), 176}},
  {{WHITE + (LIGHTGRAY << 4), 178}, {WHITE + (LIGHTGRAY << 4), 177}, {WHITE + (LIGHTGRAY << 4), 177}, {WHITE + (BROWN << 4), 177}}};
  char pic[6][8] = {{24, 56, 120, 24, 24, 24, 126, 126},
                    {60, 126, 102, 14, 60, 112, 126, 126},
                    {127, 255, 198, 230, 118, 54, 246, 230},
                    {126, 126, 24, 24, 24, 24, 24, 24},
                    {242, 246, 206, 246, 246, 198, 207, 207},
                    {246, 255, 201, 243, 246, 196, 204, 207}};
  int warp[4] = {21, 128, 21, 235};
  char on_off[2][4] = {{"Off"}, {"On "}};
  monster *mt;
  int *attr;
  int kbuf[2][10];
  characters = 0;
  for (a = 0;a < 8;a++)
  {
    if (character[a].dead == 1)
      characters++;
  }
  if (characters <= 0)
  {
    cputs("No characters.\r\n");
    return;
  }
  for (a = 0;a < 10;a++)
  {
    kbuf[0][a] = 0;
    kbuf[1][a] = 0;
  }
  snd.sndon_off();
  snd.copy(ssilence);
  if (quicksaved == 0)
  {
  for (a = 0;a < 4;a++)
  {
    for (b = 0;b < 10;b++)
      walls[a][b] = (char)random(3)+176;
  }
  for (a = 0;a < 8;a++)
    character[a].playing = 0;
  for (a = 0;a < 4;a++)
  {
    c[a] = -1;
    rdu[a] = 0;
    for (b = 0;b < 10;b++)
      mon[a][b].hp = 0;
  }
  for (a = 0;a < 36;a++)
    shots[a].lifespan = 0;
  cputs("There is and old man operating the eleveator.  He asks you:\r\n");
  do {
    cputs("\"How deep will you go?\"");
    cin >> depth;
  } while (depth <= 0 || depth > 30);
  do {
    cputs("\"Who will go down first?\"");
    cin >> c[0];
  } while (character[c[0]].dead == 0);
  if (character[c[0]].items == 6)
  {
    cputs("\"You wouldn't dare go down empty-handed, Would you?\"\r\n");
    cputs("\"Here, please take a tinder box and torch.\"");
    character[c[0]].inventory[6] = 48;
    character[c[0]].number[6] = 1;
    character[c[0]].inventory[7] = 50;
    character[c[0]].number[7] = 1;
    character[c[0]].items = 8;
    character[c[0]].weight = 4;
    getch();
  }
  createmonsters();
  createdungeon();
  for (dx = 0;dx < 10;dx++)
  {
    for (dy = 0;dy < 10;dy++)
    {
      themap[dx][dy] = 0;
      maproom(dx, dy, &themap[dx][dy]);
      for (a = 0;a < 4;a++)
        pc[a].indmap[dx][dy] = themap[dx][dy];
    }
  }
  players = 1;
  defplayer(0);
  }
  else
  {
    quicksaved = 0;
    if (quickload() != 0)
    {
      perror("unable to load game");
      getkey();
      return;
    }
    for (a = 0;a < 4;a++)
      pc[a].inmenu = -1;
  }

  namebar();

  while (depth != 0)
  {
    if (players == 0)
      depth = 0;
    if (++frame == 4)
    {
      frame = 0;
      d = -1;
      dx = random(10);
      dy = random(10);
      for (a = 0;a < 4;a++)
      {
      if (c[a] != -1 && character[c[a]].playing == 1 && character[c[a]].dead == 1)
      {
        if (dx == pc[a].roomx && dy == pc[a].roomy)
          d = pc[a].rd;
        else if (character[c[a]].inventory[pc[a].ring] == 55)
        {
          d = pc[a].rd;
          dx = pc[a].roomx;
          dy = pc[a].roomy;
        }
        if (pc[a].lanlit == LIT)
        {
          if (character[c[a]].inventory[pc[a].rhand] != 47 && character[c[a]].inventory[pc[a].lhand] != 47)
            pc[a].lanlit = UNLIT;
          else
          {
            if ((character[c[a]].oillight -= 1) <= 0)
              pc[a].lanlit = UNLIT;
          }
        }
        else if (pc[a].torchlit == LIT)
        {
          if (character[c[a]].inventory[pc[a].rhand] != 50 && character[c[a]].inventory[pc[a].lhand] != 50)
            pc[a].torchlit = UNLIT;
          else
          {
            if ((character[c[a]].torchlight -= 1) <= 0)
            {
              pc[a].torchlit = UNLIT;
              character[c[a]].torchlight = itemlist[50].level;
              if (character[c[a]].inventory[pc[a].rhand] == 50)
              {
                if (removeitem(c[a], pc[a].rhand) == 0)
                  shift(a, pc[a].rhand);
              }
              else if (character[c[a]].inventory[pc[a].lhand] == 50)
              {
                if (removeitem(c[a], pc[a].lhand) == 0)
                  shift(a, pc[a].lhand);
              }
              pc[a].upd = (pc[a].upd | UDHANDS | UDWEIGHT);
            }
          }
        }
        if ((EWC & character[c[a]].cursed) == EWC)
        {
          if (--pc[a].hp <= 0)
          {
            character[c[b]].dead = 0;
            if (--players == 0)
            {
              for (d = 0;d < 4;d++)
              {
                if (c[d] != -1)
                  character[c[d]].playing = 0;
                return;
              }
            }
          }
          pc[a].hit = 1;
          pc[a].upd |= UDHP;
        }
        if (character[c[a]].inventory[pc[a].ring] == 18)
        {
          if (pc[a].hp < character[c[a]].hpcap)
            pc[a].hp++;
          pc[a].upd |= UDHP;
        }
        else if (character[c[a]].inventory[pc[a].ring] == 34)
        {
          if (pc[a].mp < character[c[a]].mpcap)
            pc[a].mp++;
          pc[a].upd |= UDMP;
        }
      }
        for (b = 0;b < 10;b++)
        {
        if (mon[a][b].hp > 0)
        {
          if ((EWC & mon[a][b].cursed) == EWC)
          {
            if (--mon[a][b].hp <= 0)
            {
              makegoody(a, mon[a][b].x, mon[a][b].y);
              map[rooms[a][X]][rooms[a][Y]].monsters--;
              map[rooms[a][X]][rooms[a][Y]].goodies++;
            }
            mon[pc[a].rd][b].hit = 2;
          }
        }
        }
      }
      if (dx != startx && dy != starty)
      {
        if (map[dx][dy].monsters < 10 && (random(50 - depth) == 0 || depth > 50))
        {
          map[dx][dy].monsters++;
          if (d != -1)
          {
            for (a = 1;a < 5;a++)
            {
              if (doors[dx + doorx[a-1]][dy * 2 + doory[a-1]] % 10 == OPEN && doors[dx + doorx[a-1]][dy * 2 + doory[a-1]] != SOLID)
                break;
            }
            switch (a)
            {
              case MUP: b = 4; e = 0; break;
              case MDOWN: b = 4; e = 9; break;
              case MRIGHT: b = 9; e = 4; break;
              case MLEFT: b = 0; e = 4; break;
              case 5: b = 4; e = 4; break;
            }
            for (a = 0;a < 10;a++)
            {
              if (mon[d][a].hp <= 0)
              {
                mon[d][a].hp = map[dx][dy].monstertype->hpcap;
                mon[d][a].cursed = NONE;
                mon[d][a].x = b;
                mon[d][a].y = e;
                mon[d][a].hit = 0;
                mon[d][a].target = -1;
                snd.copy(sfind);
                break;
              }
            }
            for (a = 0;a < 4;a++)
              if (pc[a].roomx == dx && pc[a].roomy == dy)
                pc[a].upd |= UDMONEY;
          }
        }
      }
      if (random(30-depth) == 0)
      {
        dx = random(10);
        dy = random(10);
        if (!(dx == startx && dy == starty) && map[dx][dy].traps < 80)
          map[dx][dy].traps++;
      }
    }
    do {
    a = 0;
    p1key = NONE;
    p2key = NONE;
    a = getkey();
    if (a == playkeys[0].up)
      p1key = MUP;
    if (a == playkeys[0].down)
      p1key = MDOWN;
    if (a == playkeys[0].right)
      p1key = MRIGHT;
    if (a == playkeys[0].left)
      p1key = MLEFT;
    if (a == playkeys[0].rhand)
      p1key = RHAND;
    if (a == playkeys[0].lhand)
      p1key = LHAND;
    if (a == playkeys[0].menu)
      p1key = MENU;
    if (a == playkeys[0].drop)
      p1key = DROP;

    if (a == playkeys[1].up)
      p2key = MUP;
    if (a == playkeys[1].down)
      p2key = MDOWN;
    if (a == playkeys[1].right)
      p2key = MRIGHT;
    if (a == playkeys[1].left)
      p2key = MLEFT;
    if (a == playkeys[1].rhand)
      p2key = RHAND;
    if (a == playkeys[1].lhand)
      p2key = LHAND;
    if (a == playkeys[1].menu)
      p2key = MENU;
    if (a == playkeys[1].drop)
      p2key = DROP;
    if (a == ESCAPE)
    {
                   snd.pstop(1);
                   textattr(LIGHTGRAY + (BLACK << 4));
                   window(1, 1, 80, 25);
                   pausescr(soundstat);
                   cx = 1;
                   ox = 0;
                   a = 0;
                   do {
                     for (b = 0;b < 4;b++)
                     {
                       gotoxy(30, 5+b);
                       if (c[b] == -1)
                         cprintf("Character: X");
                       else
                         cprintf("Character: %d", c[b]);
                     }
                     if (cx < 1)
                       cx = 8;
                     else if (cx > 8)
                       cx = 1;
                     if (cx != ox)
                     {
                       gotoxy(28, ox);
                       putch(32);
                       gotoxy(28, cx);
                       putch('>');
                       ox = cx;
                     }
                     switch(getkey())
                     {
                       case UP: cx--; break;
                       case DOWN: cx++; break;
                       case SPACE: switch (cx)
                                   {
                                     case 1: a = 1; break;
                                     case 2: b = 0;
                                             for (d = 0;d < 4;d++)
                                               if (c[d] != -1)
                                                 b = 1;
                                             if (b == 1)
                                             {
                                               gotoxy(1, 20);
                                               cputs("All characters have not left.\r\n");
                                               cputs("(r)eturn to game, (k)ill characters, or (s)ave game?\r\n");
                                               b = 0;
                                               do {
                                                 switch (getch())
                                                 {
                                                   case 'r': b = 1; break;
                                                   case 'k': a = 1;
                                                             b = 1;
                                                             depth = 0;
                                                             break;
                                                   case 's': if (quicksave() != 0)
                                                               cputs("Sorry save error. Press any key to return to main menu");
                                                             else
                                                             {
                                                               cputs("Game saved.  Press any key to exit program");
                                                               quicksaved = 1;
                                                             }
                                                             getch();
                                                             return;
                                                 }
                                               } while (b == 0);
                                             }
                                             else
                                               depth = 0;
                                             break;
                                     case 3: b = 0;
                                             do {
                                               switch (getkey())
                                               {
                                                 case LEFT: gamespeed--; break;
                                                 case RIGHT: gamespeed++; break;
                                                 case SPACE: b = 1; break;
                                               }
                                               gotoxy(38, 3);
                                               cprintf("%d", gamespeed);
                                             } while (b == 0);
                                             break;
                                     case 4: (soundstat == 1) ? (soundstat = 0) : (soundstat = 1);
                                             gotoxy(37, 4);
                                             cputs(on_off[soundstat]);
                                             snd.sndon_off(soundstat);
                                             break;
                                     case 5: gotoxy(28, cx);
                                             putch(SPACE);
                                             chmenu(0, soundstat);
                                             ox = 0;
                                             break;
                                     case 6: gotoxy(28, cx);
                                             putch(SPACE);
                                             chmenu(1, soundstat);
                                             ox = 0;
                                             break;
                                     case 7: gotoxy(28, cx);
                                             putch(SPACE);
                                             chmenu(2, soundstat);
                                             ox = 0;
                                             break;
                                     case 8: gotoxy(28, cx);
                                             putch(SPACE);
                                             chmenu(3, soundstat);
                                             ox = 0;
                                             break;
                                   }
                                   break;
                     }
                   } while (a == 0);
                   clrscr();
                   namebar();
                   for (b = 0;b < 4;b++)
                   {
                     if (pc[b].control == PLAYER1 || pc[b].control == PLAYER2)
                     {
                       for (a = 0;a < 4;a++)
                         if (pc[a].control == pc[b].control && a != b)
                           pc[a].control = STAND;
                       pc[b].inmenu = -1;
                     }
                   }
                   for (b = 0;b < 4;b++)
                   {
                     if (pc[b].view != NONE)
                     {
                       for (a = 0;a < 4;a++)
                       {
                         if (pc[a].view == pc[b].view && a != b)
                         {
                           if (pc[b].control != PLAYER1 && pc[b].control != PLAYER2)
                             pc[b].view = NONE;
                           else if (pc[a].control != PLAYER1 && pc[a].control != PLAYER2)
                             pc[a].view = NONE;
                           else
                           {
                             pc[b].view = PLAYER1;
                             pc[a].view = PLAYER2;
                           }
                         }
                       }
                       pc[b].inmenu = -1;
                     }
                   }
    }
    if (p1key != 0)
      stickkey(&kbuf[0], p1key);
    if (p2key != 0)
      stickkey(&kbuf[1], p2key);
    } while (a != 0);
    for (a = 0;a < 4;a++)
    {
    if (c[a] != -1 && character[c[a]].playing == 1 && character[c[a]].dead == 1)
    {
      if ((FLC & character[c[a]].cursed) == FLC)
      {
        dx = 0;
        dy = 0;
        switch (random(4)+1)
        {
          case MUP: dy = -1; break;
          case MDOWN: dy = 1; break;
          case MRIGHT: dx = 1; break;
          case MLEFT: dx = -1; break;
        }
        if (pc[a].fx + dx < 0 || pc[a].fx + dx > 9 || pc[a].fy + dy < 0 || pc[a].fy + dy > 9)
        {
          dx = 0;
          dy = 0;
        }
        pc[a].fx += dx;
        pc[a].fy += dy;
        if (pc[a].fx == 4 && pc[a].fy == 4 && map[pc[a].roomx][pc[a].roomy].torch == UNLIT)
          map[pc[a].roomx][pc[a].roomy].torch = LIT;
      }
      if (pc[a].inaction == 0)
      {
        switch (pc[a].control)
        {
          case PLAYER1: humancon(pullkey(&kbuf[0]), a); break;
          case PLAYER2: humancon(pullkey(&kbuf[1]), a); break;
          case STAND: if (random(3) != 0)
                        humancon(attacknear(a), a);
                      break;
          case TASK: if (random(3) != 0)
                       humancon(task(a), a);
                     break;
          case FOLLOW1:
          case FOLLOW2: if (random(3) != 0)
                          humancon(follow(a), a);
                        break;
        }
      }
      if (pc[a].inaction != 0)
      {
        switch (pc[a].facing)
        {
          case MUP: dy = -1; break;
          case MDOWN: dy = 1; break;
          case MRIGHT: dx = 1; break;
          case MLEFT: dx = -1; break;
        }
        if (pc[a].inaction < 10)
        {
          findfree(&projec, 1);
          if (pc[a].moving < MRIGHT)
            d = 179;
          else
            d = 196;
          sc(projec[0], pc[a].x, pc[a].y, pc[a].facing, character[c[a]].magic * character[c[a]].magic, 12, 0, a+10, pc[a].rd, YELLOW, d, 92, d, 47);
        }
        if (--pc[a].inaction == 10)
          pc[a].inaction = 0;
      }
    }
    }
    for (a = 0;a < 4;a++)
    {
    if (rdu[a] > 0)
    {
      for (b = 0;b < 4;b++)
        if (pc[b].rd == a && c[b] != -1)
          mt = map[pc[b].roomx][pc[b].roomy].monstertype;
      for (b = 0;b < 10;b++)
      {
        dx = 0;
        dy = 0;
        if (mon[a][b].hp < 0)
          mon[a][b].hp = 0;
        if (mon[a][b].hp > 0)
        {
          if (mon[a][b].target == -1)
          {
            d = random(rdu[a])+1;
            for (e = 0;e < 4;e++)
            {
              if (pc[e].rd == a && c[e] != -1)
              {
                if (--d == 0)
                  break;
              }
            }
            mon[a][b].target = e;
          }
          e = NONE;
          d = mon[a][b].target;
          if (((mon[a][b].x-1 == pc[d].x && mt->brains != 3 && mt->brains != 4) || (mon[a][b].x > pc[d].x && (mt->brains == 3 || mt->brains == 4))) && mon[a][b].y == pc[d].y)
            e = MLEFT;
          if (((mon[a][b].x+1 == pc[d].x && mt->brains != 3 && mt->brains != 4) || (mon[a][b].x < pc[d].x && (mt->brains == 3 || mt->brains == 4))) && mon[a][b].y == pc[d].y)
            e = MRIGHT;
          if (mon[a][b].x == pc[d].x && ((mon[a][b].y > pc[d].y && (mt->brains == 3 || mt->brains == 4)) || (mon[a][b].y-1 == pc[d].y && mt->brains != 3 && mt->brains != 4)))
            e = MUP;
          if (mon[a][b].x == pc[d].x && ((mon[a][b].y < pc[d].y && (mt->brains == 3 || mt->brains == 4)) || (mon[a][b].y+1 == pc[d].y && mt->brains != 3 && mt->brains != 4)))
            e = MDOWN;
          if (mt->brains == 5)
          {
            if (random(500) == 0)
            {
              e = -1;
              mon[a][b].cursed = NONE;
              snd.copy(scure);
            }
            if (e != NONE && character[c[mon[a][b].target]].inventory[pc[mon[a][b].target].ring] != 51)
            {
              switch (random(1000))
              {
                case EWC: character[c[mon[a][b].target]].cursed |= EWC; e = -1; break;
                case WOWC: character[c[mon[a][b].target]].cursed |= WOWC; e = -1; break;
                case ASFC: character[c[mon[a][b].target]].cursed |= ASFC; e = -1; break;
                case FATC: character[c[mon[a][b].target]].cursed |= FATC; e = -1; break;
                case IFC: character[c[mon[a][b].target]].cursed |= IFC; e = -1; break;
              }
              pc[mon[a][b].target].upd |= UDCURSE;
              snd.copy(scurse);
            }
          }
          if (e == NONE)
          {
            if (mt->brains == 0 || mt->brains == 3)
            {
              g = random(4)+1;
              switch (g)
              {
                case MUP: dy = -1; break;
                case MDOWN: dy = 1; break;
                case MRIGHT: dx = 1; break;
                case MLEFT: dx = -1; break;
              }
              if (random (2) == 0)
              {
                e = g;
                dx = 0;
                dy = 0;
              }
            }
            if (mt->brains == 1 || mt->brains == 2 || mt->brains == 4 || mt->brains == 5)
            {
              d = random(2);
              if (d == 0)
              {
                if (pc[mon[a][b].target].x - mon[a][b].x < 0)
                  dx = -1;
                else if (pc[mon[a][b].target].x - mon[a][b].x > 0)
                  dx = 1;
              }
              else
              {
                if (pc[mon[a][b].target].y - mon[a][b].y < 0)
                  dy = -1;
                else if (pc[mon[a][b].target].y - mon[a][b].y > 0)
                  dy = 1;
              }
              d = floor[a][mon[a][b].x + dx][mon[a][b].y + dy] / 10;
              if ((mt->brains == 2 || mt-> brains == 5) && (d == TRAP / 10 || d == CHEST / 10 || d == TCHEST / 10 || (mon[a][b].x + dx == 4 && mon[a][b].y + dy == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH)))
              {
                dx *= -1;
                dy *= -1;
                if (dx == 0)
                {
                  d = floor[a][mon[a][b].x + 1][mon[a][b].y] / 10;
                  if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10 && mon[a][b].x != 9 && !(mon[a][b].x + 1 == 4 && mon[a][b].y == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH))
                  {
                    dx = 1;
                    dy = 0;
                  }
                  d = floor[a][mon[a][b].x - 1][mon[a][b].y] / 10;
                  if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10 && mon[a][b].x != 0 && !(mon[a][b].x - 1 == 4 && mon[a][b].y == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH))
                  {
                    dx = -1;
                    dy = 0;
                  }
                }
                else
                {
                  d = floor[a][mon[a][b].x][mon[a][b].y + 1] / 10;
                  if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10 && mon[a][b].y != 9 && !(mon[a][b].x == 4 && mon[a][b].y + 1 == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH))
                  {
                    dx = 0;
                    dy = 1;
                  }
                  d = floor[a][mon[a][b].x][mon[a][b].y - 1] / 10;
                  if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10 && mon[a][b].y != 0 && !(mon[a][b].x == 4 && mon[a][b].y - 1 == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH))
                  {
                    dx = 0;
                    dy = -1;
                  }
                }
              }
            }
          }
          if ((mt->brains == 2 || mt->brains == 5) && mon[a][b].hit == 1)
          {
            dx *= -1;
            dy *= -1;
            if (dx == 0 || e == MUP || e == MDOWN)
            {
              d = floor[a][mon[a][b].x + 1][mon[a][b].y] / 10;
              if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10)
              {
                dx = 1;
                dy = 0;
              }
              d = floor[a][mon[a][b].x - 1][mon[a][b].y] / 10;
              if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10)
              {
                dx = -1;
                dy = 0;
              }
            }
            else if (dy == 0 || e == MRIGHT || e == MLEFT)
            {
              d = floor[a][mon[a][b].x][mon[a][b].y + 1] / 10;
              if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10)
              {
                dx = 0;
                dy = 1;
              }
              d = floor[a][mon[a][b].x][mon[a][b].y - 1] / 10;
              if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10)
              {
                dx = 0;
                dy = -1;
              }
            }
            e = NONE;
          }
            if ((IFC & mon[a][b].cursed) == IFC)
            {
              g = 0;
              for (d = 0;d < 4;d++)
              {
                if (doors[rooms[a][X] + doorx[d]][rooms[a][Y] * 2 + doory[d]] % 10 == OPEN && doors[rooms[a][X] + doorx[d]][rooms[a][Y] * 2 + doory[d]] != SOLID)
                  g = d;
              }
              if (g == 0)
              {
                dx *= -1;
                dy *= -1;
              }
              else
              {
                switch (g)
                {
                  case MUP-1: dx = 4;
                            dy = 0;
                            break;
                  case MDOWN-1: dx = 4;
                              dy = 9;
                              break;
                  case MRIGHT-1: dx = 9;
                               dy = 4;
                               break;
                  case MLEFT-1: dx = 0;
                              dy = 4;
                              break;
                }
                if (mon[a][b].x == dx && mon[a][b].y == dy)
                {
                  mon[a][b].hp = 0;
                  map[rooms[a][X]][rooms[a][Y]].monsters--;
                }
                else if (dx - mon[a][b].x < 0)
                {
                  dx = -1;
                  dy = 0;
                }
                else if (dx - mon[a][b].x > 0)
                {
                  dx = 1;
                  dy = 0;
                }
                else if (dy - mon[a][b].y < 0)
                {
                  dx = 0;
                  dy = -1;
                }
                else if (dy - mon[a][b].y > 0)
                {
                  dx = 0;
                  dy = 1;
                }
              }
            }
          if (mon[a][b].x + dx < 0 || mon[a][b].x + dx > 9 || mon[a][b].y + dy < 0 || mon[a][b].y + dy > 9)
          {
            dx = 0;
            dy = 0;
          }
          for (d = 0;d < 4;d++)
          {
            if (mon[a][b].x + dx == pc[d].x && mon[a][b].y + dy == pc[d].y && character[c[d]].playing == 1)
            {
              dx = 0;
              dy = 0;
            }
          }
          for (d = 0;d < 10;d++)
          {
            if (d != b && mon[a][b].x + dx == mon[a][d].x && mon[a][b].y + dy == mon[a][d].y && mon[a][d].hp > 0)
            {
              dx = 0;
              dy = 0;
            }
          }
          d = floor[a][mon[a][b].x + dx][mon[a][b].y + dy] / 10;
          if (d == CHEST/10 || d == TCHEST/10 || (map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH && mon[a][b].x + dx == 4 && mon[a][b].y + dy == 4))
          {
            dx = 0;
            dy = 0;
          }
          if ((random(30)+1 > mt->speed && (WOWC & mon[a][b].cursed) != WOWC) || (random(100) == 0 && (WOWC & mon[a][b].cursed) == WOWC) || ((IFC & mon[a][b].cursed) == IFC && (WOWC & mon[a][b].cursed) != WOWC))
          {
            mon[a][b].x += dx;
            mon[a][b].y += dy;
            if (dx != 0 || dy != 0 && snd.nplay() == 0)
            {
              snd.copy(sblank, &sb);
              sb[0] = 100;
              snd.copy(sb);
            }
            if ((dx != 0 || dy != 0) && d == TRAP/10)
            {
              mon[a][b].hit = 1;
              if ((mon[a][b].hp -= random(depth)) <= 0 && mt->type == WERE)
                mon[a][b].hp = 0;
              map[pc[mon[a][b].target].roomx][pc[mon[a][b].target].roomy].traps--;
              floor[a][mon[a][b].x][mon[a][b].y] -= TRAP;
              if (floor[a][mon[a][b].x][mon[a][b].y] % 10 == TILE)
                floor[a][mon[a][b].x][mon[a][b].y] += TILE + random(3) + 1;
              if (mon[a][b].hp <= 0)
              {
                makegoody(a, mon[a][b].x, mon[a][b].y);
                map[rooms[a][X]][rooms[a][Y]].monsters--;
                map[rooms[a][X]][rooms[a][Y]].goodies++;
              }
            }
            if (dx == 0 && dy == 0 && e != NONE && e != -1)
            {
              findfree(&projec, 1);
              switch (e)
              {
                case MUP: g = 220; break;
                case MDOWN: g = 223; break;
                case MRIGHT: g = 221; break;
                case MLEFT: g = 222; break;
              }
              if (mt->brains == 3 || mt->brains == 4)
                sc(projec[0], mon[a][b].x, mon[a][b].y, e, mt->level, 12, 0, b, a, RED, 176, 177, 178, 177);
              else
                sc(projec[0], mon[a][b].x, mon[a][b].y, e, mt->level, 1, 0, b, a, BROWN, g, g, g, g);
            }
          }
        }
        if (mon[a][b].hit == 1)
          mon[a][b].hit = 0;
      }
    }
    }
    for (a = 0;a < 36;a++)
    {
      if (shots[a].lifespan <= -100)
        shots[a].lifespan = -1;
      if (shots[a].lifespan > 0)
      {
        dx = 0;
        dy = 0;
        switch (shots[a].moving)
        {
          case -1: (random(2)) ? (dx = sign(mon[shots[a].rd][pc[shots[a].who-10].casting].x - shots[a].x)) : (dy = sign(mon[shots[a].rd][pc[shots[a].who-10].casting].y - shots[a].y)); break;
          case MUP: dy = -1; break;
          case MDOWN: dy = 1; break;
          case MRIGHT: dx = 1; break;
          case MLEFT: dx = -1; break;
        }
        shots[a].x += dx;
        shots[a].y += dy;
        if ((shots[a].x > 9) || (shots[a].x < 0) || (shots[a].y > 9) || (shots[a].y < 0))
        {
          if (shots[a].moving != NONE)
            d = shots[a].moving;
          else
          {
            if (shots[a].x < 0)
              d = MLEFT;
            else if (shots[a].x > 9)
              d = MRIGHT;
            else if (shots[a].y < 0)
              d = MUP;
            else if (shots[a].y > 9)
              d = MDOWN;
          }
          if (shots[a].who < 10)
          {
            for (b = 0;b < 4;b++)
            {
              if (pc[b].rd == shots[a].rd && c[b] != -1)
                break;
            }
            checkdoor(&doors[pc[b].roomx + doorx[d-1]][pc[b].roomy * 2 + doory[d-1]], dx, dy, shots[a].x, shots[a].y, b, shots[a].level);
            gdoor(d, b);
          }
          else
          {
            checkdoor(&doors[pc[shots[a].who-10].roomx + doorx[d-1]][pc[shots[a].who-10].roomy * 2 + doory[d-1]], dx, dy, shots[a].x, shots[a].y, shots[a].who-10, shots[a].level);
            gdoor(d, shots[a].who-10);
          }
          shots[a].lifespan = 0;
        }
        if (floor[shots[a].rd][shots[a].x][shots[a].y] / 10 == CHEST / 10 || floor[shots[a].rd][shots[a].x][shots[a].y] / 10 == TCHEST / 10)
        {
          checkchest(shots[a].rd, 0, 0, shots[a].x, shots[a].y, shots[a].level);
          shots[a].lifespan = 0;
        }
        if (shots[a].special == 110)
        {
          if (shots[a].lifespan == 1)
          {
            findfree(&projec, 9);
            sc(projec[0], shots[a].x, shots[a].y, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            sc(projec[1], shots[a].x, shots[a].y+1, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            sc(projec[2], shots[a].x, shots[a].y-1, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            sc(projec[3], shots[a].x+1, shots[a].y, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            sc(projec[4], shots[a].x+1, shots[a].y+1, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            sc(projec[5], shots[a].x+1, shots[a].y-1, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            sc(projec[6], shots[a].x-1, shots[a].y, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            sc(projec[7], shots[a].x-1, shots[a].y+1, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            sc(projec[8], shots[a].x-1, shots[a].y-1, NONE, 500, 8, 200, shots[a].who, shots[a].rd, fire[random(5)], 176, 177, 178, 177);
            snd.copy(sboom);
          }
        }
        else if (shots[a].who < 10)
        {
          for (b = 0;b < 4;b++)
          {
          if (c[b] != -1 && character[c[b]].playing == 1 && character[c[b]].dead == 1 && pc[b].rd == shots[a].rd)
          {
            if (shots[a].x == pc[b].x && shots[a].y == pc[b].y)
            {
              if (((FATC & character[c[b]].cursed) == FATC || random(character[c[b]].guard + character[c[b]].luck) < shots[a].level * 4) && (ASFC & mon[shots[a].rd][shots[a].who].cursed) != ASFC && pc[b].inaction < 10)
              {
                g = shots[a].level / 10;
                e = ((shots[a].level % 10) * itemlist[character[c[b]].inventory[pc[b].wearing]].level) / 10;
                if (((shots[a].level % 10) * itemlist[character[c[b]].inventory[pc[b].wearing]].level) % 10 > 0)
                  e++;
                g = shots[a].level - ((g * itemlist[character[c[b]].inventory[pc[b].wearing]].level) + e);
                if (g <= 0)
                  g = 1;
                if (character[c[b]].inventory[pc[b].ring] == 21)
                {
                  pc[b].mp -= g;
                  if (pc[b].mp < 0)
                  {
                    pc[b].hp += pc[b].mp;
                    pc[b].mp = 0;
                  }
                  pc[b].upd |= UDMP;
                }
                else
                  pc[b].hp -= g;
                if (pc[b].hp <= 0)
                {
                  character[c[b]].dead = 0;
                  if (--players == 0)
                    depth = 0;
                  snd.copy(sdead);
                }
                if (character[c[b]].inventory[pc[b].wearing] == 43)
                  mon[shots[a].rd][shots[a].who].cursed |= ASFC;
                pc[b].hit = 1;
                snd.copy(splayhit);
                shots[a].lifespan = 0;
                pc[b].foe = shots[a].who;
                mon[shots[a].rd][shots[a].who].target = b;
                pc[b].upd |= UDHP;
              }
            }
          }
          }
        }
        else
        {
          for (b = 0;b < 10;b++)
          {
          if (mon[shots[a].rd][b].hp > 0)
          {
            if (shots[a].x == mon[shots[a].rd][b].x && shots[a].y == mon[shots[a].rd][b].y)
            {
              if (((FATC & mon[shots[a].rd][b].cursed) == FATC || random(map[pc[shots[a].who-10].roomx][pc[shots[a].who-10].roomy].monstertype->level) <= character[c[shots[a].who-10]].luck) && (ASFC & character[c[shots[a].who-10]].cursed) != ASFC)
              {
                mon[shots[a].rd][b].hp -= random(shots[a].level+1);
                if (map[pc[shots[a].who-10].roomx][pc[shots[a].who-10].roomy].monstertype->type == WERE && shots[a].special != WERE && mon[shots[a].rd][b].hp <= 0)
                  mon[shots[a].rd][b].hp = 1;
                if (mon[shots[a].rd][b].hp <= 0)
                {
                  makegoody(shots[a].rd, mon[shots[a].rd][b].x, mon[shots[a].rd][b].y);
                  character[c[shots[a].who-10]].experience += map[pc[shots[a].who-10].roomx][pc[shots[a].who-10].roomy].monstertype->level;
                  map[pc[shots[a].who-10].roomx][pc[shots[a].who-10].roomy].monsters--;
                  map[pc[shots[a].who-10].roomx][pc[shots[a].who-10].roomy].goodies++;
                  pc[shots[a].who-10].upd |= UDEXPER;
                  snd.copy(sdead);
                }
                if (shots[a].special == 20)
                  mon[shots[a].rd][b].cursed = (mon[shots[a].rd][b].cursed | FATC | EWC);
                mon[shots[a].rd][b].hit = 1;
                snd.copy(smonhit);
                shots[a].lifespan = 0;
                pc[shots[a].who-10].foe = b;
                mon[pc[shots[a].who-10].rd][b].target = shots[a].who-10;
              }
            }
          }
          }
        }
      }
    }
    for (a = 0;a < 4;a++)
    {
    if (c[a] != -1 && character[c[a]].playing == 1)
    {
      if (pc[a].view == PLAYER1)
        window(1, 1, 80, 12);
      if (pc[a].view == PLAYER2)
        window(1, 14, 80, 25);
      if (pc[a].view == PLAYER1 || pc[a].view == PLAYER2)
      {
        if (pc[a].inmenu == -1)
        {
          textattr(LIGHTGRAY + (BLACK << 4));
          clrscr();
          gotoxy(13, 1);
          cprintf("H e a l t h        /%d", character[c[a]].hpcap);
          gotoxy(13, 2);
          cprintf("M a g i c          /%d", character[c[a]].mpcap);
          gotoxy(13, 3);
          cprintf("M o n e y");
          gotoxy(13, 4);
          cprintf("W e i g h t        /%d", character[c[a]].stamina * 10);
          gotoxy(13, 5);
          cprintf("E x p e r i e n c e");
          gotoxy(13, 6);
          cprintf("L a s t   F o u n d");
          gotoxy(13, 7);
          cprintf("C a s t i n g   o n ");
          gotoxy(13, 8);
          cprintf("R i g h t   H a n d");
          gotoxy(13, 9);
          cprintf("L e f t     H a n d");
          gotoxy(13, 10);
          cprintf("C u r s e s:");
          gotoxy(16, 11);
          cprintf("%ss", map[pc[a].roomx][pc[a].roomy].monstertype->monstername);
          gotoxy(36, 11);
          cprintf("L e v e l");
          gotoxy(13, 12);
          cprintf("%s", map[pc[a].roomx][pc[a].roomy].monstertype->monstername);
          gotoxy(36, 12);
          cprintf("H e a l t h       /%d", map[pc[a].roomx][pc[a].roomy].monstertype->hpcap);
          for (b = 0;b < 4;b++)
          {
            if (c[b] != -1 && character[c[b]].playing == 1)
            {
              gotoxy(40, 1+b);
              cprintf("%d-%s", c[b], character[c[b]].playername);
            }
          }
          for (dx = 0;dx < 8;dx++)
          {
            for (dy = 0;dy < 8;dy++)
            {
              gotoxy(60 + (dx*2), dy + 1);
              if ((bits[dx] & pic[pc[a].control-1][dy]) == bits[dx])
              {
                putch(219);
                putch(219);
              }
            }
          }
          gotoxy(65, 9);
          cprintf("%s", controls[pc[a].control-1]);
          pc[a].upd = (char)255;
          pc[a].inmenu = 1;
          gotoxy(60, 11);
          b = map[pc[a].roomx][pc[a].roomy].monstertype->brains;
          cputs("Intelligence:");
          gotoxy(60, 12);
          switch(b)
          {
            case 0:
            case 1:
            case 2: cputs("Punching"); break;
            case 3:
            case 4: cputs("Magic"); break;
            case 5: cputs("Casting"); break;
          }
          putch(SPACE);
          switch(b)
          {
            case 0:
            case 3: cputs("Wandering"); break;
            case 1:
            case 4: cputs("Stupid"); break;
            case 2:
            case 5: cputs("Smart(er)"); break;
          }
        }
        else if (pc[a].inmenu == -2)
        {
          textattr(LIGHTGRAY + (BLACK << 4));
          clrscr();
          gotoxy(13, 2);
          cprintf("Casting- ");
          for (b = 0;b < 10;b++)
          {
            textattr(YELLOW + (RED << 4));
            if (mon[pc[a].rd][b].hp > 0)
              cprintf("%c", b+48);
            else
              cprintf("X");
            textattr(LIGHTGRAY + (BLACK << 4));
            cprintf("   ");
          }
          for (b = 0;b < 4;b++)
          {
            textattr(WHITE + (BLACK << 4));
            if (character[c[b]].dead == 1 && character[c[b]].playing == 1)
              cprintf("%c", c[b]+48);
            else if (character[c[b]].playing == 1)
              cprintf("X");
            else
              cprintf(" ");
            textattr(LIGHTGRAY + (BLACK << 4));
            cprintf("   ");
          }
          for (dx = 0;dx < 3;dx++)
          {
            for (dy = 0;dy < 10;dy++)
            {
              gotoxy(17+dx*22, dy+3);
              e = dx * 10 + dy;
              if (character[c[a]].inventory[e] != 100)
              {
                cprintf("%s", itemlist[character[c[a]].inventory[e]].itemname);
                gotoxy(31+dx*22, dy+3);
                cprintf(" %d", character[c[a]].number[e]);
                if (character[c[a]].number[e] < 100);
                  putch(SPACE);
              }
            }
          }
          pc[a].newright = pc[a].rhand;
          pc[a].newleft = pc[a].lhand;
          pc[a].newwear = pc[a].wearing;
          pc[a].newring = pc[a].ring;
          pc[a].inmenu = 2;
        }
        else if (pc[a].inmenu == -3)
        {
          gotoxy(13+pc[a].mx*22, pc[a].my+3);
          textattr(LIGHTGRAY + (BLACK << 4));
          putch(SPACE);
          pc[a].inmenu = 3;
        }
        if (pc[a].inmenu == 1 || pc[a].inmenu == 4)
        {
          textattr(LIGHTGRAY + (BLACK << 4));
          if ((UDHP & pc[a].upd) == UDHP)
            update(MAINX, HPY, pc[a].hp);
          if ((UDMP & pc[a].upd) == UDMP)
            update(MAINX, MPY, pc[a].mp);
          if ((UDMONEY & pc[a].upd) == UDMONEY)
          {
            if (character[c[a]].money > 30000 || character[c[a]].money < 0)
              character[c[a]].money = 30000;
            update(MAINX, MONEYY, character[c[a]].money);
            if (pc[a].casting < 10)
            {
              textattr(YELLOW + (RED << 4));
              if (mon[pc[a].rd][pc[a].casting].hp <= 0)
                b = (int)'X';
              else
                b = pc[a].casting+48;
            }
            else
            {
              textattr(WHITE + (BLACK << 4));
              if (c[pc[a].casting - 10] == -1)
                b = (int)'X';
              else
                b = c[pc[a].casting - 10]+48;
            }
            gotoxy(HANDX, FOUNDY+1);
            cprintf("%c", b);
            textattr(LIGHTGRAY + (BLACK << 4));
          }
          if ((UDWEIGHT & pc[a].upd) == UDWEIGHT)
          {
            if ((WOWC & character[c[a]].cursed) == WOWC)
              b = 500;
            else
              b = 0;
            if (character[c[a]].inventory[pc[a].ring] == 58)
              d = 2;
            else
              d = 1;
            update(MAINX, WEIGHTY, (character[c[a]].weight + b) / d);
          }
          if ((UDEXPER & pc[a].upd) == UDEXPER)
            update(EXPERX, EXPERY, character[c[a]].experience);
          if ((UDHANDS & pc[a].upd) == UDHANDS)
          {
            textattr(LIGHTGRAY + (BLACK << 4));
            gotoxy(HANDX, RHANDY);
            cprintf("%s %d ", itemlist[character[c[a]].inventory[pc[a].rhand]].itemname, character[c[a]].number[pc[a].rhand]);
            gotoxy(HANDX, LHANDY);
            cprintf("%s %d ", itemlist[character[c[a]].inventory[pc[a].lhand]].itemname, character[c[a]].number[pc[a].lhand]);
          }
          if ((UDFOUND & pc[a].upd) == UDFOUND)
          {
            textattr(LIGHTGRAY + (BLACK << 4));
            gotoxy(HANDX, FOUNDY);
            cprintf("%s ", itemlist[pc[a].itemfound].itemname);
          }
          if ((UDCURSE & pc[a].upd) == UDCURSE)
          {
            gotoxy(CURSEX, CURSEY);
            if ((EWC & character[c[a]].cursed) == EWC)
              cprintf("E Wound ");
            else
              cprintf("        ");
            if ((WOWC & character[c[a]].cursed) == WOWC)
              cprintf("Wt/World ");
            else
              cprintf("         ");
            if ((ASFC & character[c[a]].cursed) == ASFC)
              cprintf("Aim/Fail ");
            else
              cprintf("         ");
            if ((FATC & character[c[a]].cursed) == FATC)
              cprintf("Foe/True ");
            else
              cprintf("         ");
            if ((IFC & character[c[a]].cursed) == IFC)
              cprintf("Fear ");
            else
              cprintf("     ");
            if ((FLC & character[c[a]].cursed) == FLC)
              cprintf("Insomnia");
            else
              cprintf("        ");
          }
            update(49, 12, mon[pc[a].rd][pc[a].foe].hp);
            gotoxy(32, 12);
            cprintf("%d", pc[a].foe);
            gotoxy(13, 11);
            cprintf("%d ", map[pc[a].roomx][pc[a].roomy].monsters);
            gotoxy(46, 11);
            cprintf("%d", map[pc[a].roomx][pc[a].roomy].monstertype->level);
          pc[a].upd = NONE;
        }
        else if (pc[a].inmenu == 2)
        {
          textattr(LIGHTGRAY + (BLACK << 4));
          gotoxy(pc[a].mx*22+13, pc[a].my+3);
          putch(SPACE);
          gotoxy((pc[a].mx+=pc[a].mdx)*22+13, (pc[a].my+=pc[a].mdy)+3);
          putch('>');
          gotoxy(13, 1);
          e = pc[a].mx * 10 + pc[a].my;
          if (character[c[a]].inventory[e] != 100)
            cprintf("%s #%d $%d weight%d rating%d level%d MP's%d     ", itemlist[character[c[a]].inventory[e]].itemname, character[c[a]].number[e], itemlist[character[c[a]].inventory[e]].cost, itemlist[character[c[a]].inventory[e]].weight, itemlist[character[c[a]].inventory[e]].level, itemlist[character[c[a]].inventory[e]].reqattr, itemlist[character[c[a]].inventory[e]].magic);
          else
            cprintf("Empty                                                      ");
          gotoxy((pc[a].rhand/10)*22+15, (pc[a].rhand%10)+3);
          putch(SPACE);
          gotoxy((pc[a].lhand/10)*22+14, (pc[a].lhand%10)+3);
          putch(SPACE);
          gotoxy((pc[a].wearing/10)*22+15, (pc[a].wearing%10)+3);
          putch(SPACE);
          gotoxy((pc[a].ring/10)*22+15, (pc[a].ring%10)+3);
          putch(SPACE);
          pc[a].rhand = pc[a].newright;
          pc[a].lhand = pc[a].newleft;
          pc[a].wearing = pc[a].newwear;
          pc[a].ring = pc[a].newring;
          gotoxy((pc[a].rhand/10)*22+15, (pc[a].rhand%10)+3);
          putch('R');
          gotoxy((pc[a].lhand/10)*22+14, (pc[a].lhand%10)+3);
          putch('L');
          if (pc[a].wearing != 0)
          {
            gotoxy((pc[a].wearing/10)*22+15, (pc[a].wearing%10)+3);
            putch('*');
          }
          if (pc[a].ring != 0)
          {
            gotoxy((pc[a].ring/10)*22+15, (pc[a].ring%10)+3);
            putch(248);
          }
          pc[a].mdx = 0;
          pc[a].mdy = 0;
        }
        else if (pc[a].inmenu == 3)
        {
          textattr(LIGHTGRAY + (BLACK << 4));
          gotoxy(pc[a].casting*4+23, 2);
          putch(SPACE);
          gotoxy((pc[a].casting+=pc[a].mdx)*4+23, 2);
          putch('<');
          pc[a].mdx = 0;
        }
        e = 0;
        for (b = 0;b < 4;b++)
        {
          if (c[b] != -1 && character[c[b]].playing == 1 && character[c[b]].dead == 1)
          {
            if (pc[b].rd == pc[a].rd && (pc[b].lanlit == LIT || pc[b].torchlit == LIT || (FLC & character[c[b]].cursed) == FLC))
              e = 1;
          }
        }
        if ((map[pc[a].roomx][pc[a].roomy].torch == LIT || e == 1) && pc[a].inmenu == 4)
        {
          scrbuf[0][0] = LIGHTGRAY + (BLACK << 4);
          scrbuf[1][0] = 201;
          scrbuf[22][0] = LIGHTGRAY + (BLACK << 4);
          scrbuf[23][0] = 187;
          scrbuf[0][11] = LIGHTGRAY + (BLACK << 4);
          scrbuf[1][11] = 200;
          scrbuf[22][11] = LIGHTGRAY + (BLACK << 4);
          scrbuf[23][11] = 188;
          for (b = 1;b < 11;b++)
          {
            scrbuf[b*2][0] = LIGHTGRAY + (BLACK << 4);
            scrbuf[b*2+1][0] = 205;
            scrbuf[b*2][11] = LIGHTGRAY + (BLACK << 4);
            scrbuf[b*2+1][11] = 205;
            scrbuf[22][b] = LIGHTGRAY + (BLACK << 4);
            scrbuf[23][b] = 186;
            scrbuf[0][b] = LIGHTGRAY + (BLACK << 4);
            scrbuf[1][b] = 186;
          }
          for (dx = 0;dx < 10;dx++)
          {
            for (dy = 0;dy < 10;dy++)
            {
              if (pc[a].indmap[dx][dy] >= 16)
              {
                scrbuf[(dx+1)*2][dy+1] = DARKGRAY + (BROWN << 4);
                scrbuf[(dx+1)*2+1][dy+1] = gmap[pc[a].indmap[dx][dy] - 16];
              }
              else
              {
                scrbuf[(dx+1)*2][dy+1] = BLACK + (BROWN << 4);
                scrbuf[(dx+1)*2+1][dy+1] = gmap[pc[a].indmap[dx][dy]];
              }
            }
          }
          if (frame < 2)
          {
            scrbuf[(pc[a].roomx+1)*2][pc[a].roomy+1] = RED + (BROWN << 4);
            scrbuf[(pc[a].roomx+1)*2+1][pc[a].roomy+1] = 'X';
            scrbuf[(startx+1)*2+1][starty+1] = 254;
          }
        }
        else if (map[pc[a].roomx][pc[a].roomy].torch == LIT || e == 1)
        {
          scrbuf[0][0] = DARKGRAY + (BLACK << 4);
          scrbuf[1][0] = 177;
          scrbuf[22][0] = DARKGRAY + (BLACK << 4);
          scrbuf[23][0] = 177;
          scrbuf[0][11] = DARKGRAY + (BLACK << 4);
          scrbuf[1][11] = 177;
          scrbuf[22][11] = DARKGRAY + (BLACK << 4);
          scrbuf[23][11] = 177;
          for (b = 1;b < 11;b++)
          {
            scrbuf[b*2][0] = gwall[pc[a].rd][MUP-1][b-1][0];
            scrbuf[b*2+1][0] = gwall[pc[a].rd][MUP-1][b-1][1];
            scrbuf[b*2][11] = gwall[pc[a].rd][MDOWN-1][b-1][0];
            scrbuf[b*2+1][11] = gwall[pc[a].rd][MDOWN-1][b-1][1];
            scrbuf[22][b] = gwall[pc[a].rd][MRIGHT-1][b-1][0];
            scrbuf[23][b] = gwall[pc[a].rd][MRIGHT-1][b-1][1];
            scrbuf[0][b] = gwall[pc[a].rd][MLEFT-1][b-1][0];
            scrbuf[1][b] = gwall[pc[a].rd][MLEFT-1][b-1][1];
          }
          for (dx = 0;dx < 10;dx++)
          {
            for (dy = 0;dy < 10;dy++)
            {
              b = floor[pc[a].rd][dx][dy];
              if (b >= ITEM)
              {
                scrbuf[(dx+1)*2][dy+1] = BLACK + (LIGHTGRAY << 4);
                scrbuf[(dx+1)*2+1][dy+1] = 254;
              }
              else if (b%10 > TILE && b/10 == TCHEST/10)
              {
                scrbuf[(dx+1)*2][dy+1] = LIGHTGRAY + (BROWN << 4);
                scrbuf[(dx+1)*2+1][dy+1] = 215;
              }
              else if (b%10 > TILE)
              {
                scrbuf[(dx+1)*2][dy+1] = DARKGRAY + (LIGHTGRAY << 4);
                scrbuf[(dx+1)*2+1][dy+1] = 175+(b%10);
              }
              else if (b/10 == TRAP/10)
              {
                scrbuf[(dx+1)*2][dy+1] = YELLOW + (GREEN << 4);
                scrbuf[(dx+1)*2+1][dy+1] = 176;
              }
              else if (b/10 == TCHEST/10)
              {
                scrbuf[(dx+1)*2][dy+1] = LIGHTGRAY + (GREEN << 4);
                scrbuf[(dx+1)*2+1][dy+1] = 215;
              }
              else if (b/10 == CHEST/10)
              {
                scrbuf[(dx+1)*2][dy+1] = LIGHTGRAY + (BROWN << 4);
                scrbuf[(dx+1)*2+1][dy+1] = 215;
              }
              else if (b/10 == MONEY/10)
              {
                scrbuf[(dx+1)*2][dy+1] = YELLOW + (LIGHTGRAY << 4);
                scrbuf[(dx+1)*2+1][dy+1] = '$';
              }
              else if (b/10 == MAGIC/10)
              {
                scrbuf[(dx+1)*2][dy+1] = random(16) + (LIGHTGRAY << 4);
                scrbuf[(dx+1)*2+1][dy+1] = 4;
              }
            }
          }
          if (map[pc[a].roomx][pc[a].roomy].monstertype->type == ICED)
          {
            for (dx = 0;dx < 12;dx++)
            {
              for (dy = 0;dy < 12;dy++)
              {
                if (scrbuf[dx*2][dy] == YELLOW + (GREEN << 4))
                  scrbuf[dx*2][dy] = GREEN + (CYAN << 4);
                else if (scrbuf[dx*2][dy] == DARKGRAY + (BLACK << 4))
                  scrbuf[dx*2][dy] = DARKGRAY + (CYAN << 4);
                else if (scrbuf[dx*2][dy] == LIGHTGRAY + (BROWN << 4))
                  scrbuf[dx*2][dy] = LIGHTCYAN + (BROWN << 4);
                else
                  scrbuf[dx*2][dy] = LIGHTCYAN + (CYAN << 4);
              }
            }
          }
          if (map[pc[a].roomx][pc[a].roomy].torch != NOTORCH)
          {
            (map[pc[a].roomx][pc[a].roomy].torch == LIT) ? (scrbuf[10][5] = fire[random(5)] + (BROWN << 4)) : (scrbuf[10][5] = BLACK + (BROWN << 4));
            scrbuf[11][5] = 254;
          }
          for (g = 0;g < 4;g++)
          {
          if ((FLC & character[c[g]].cursed) == FLC && c[g] != -1 && pc[g].rd == pc[a].rd)
          {
            switch (random(6))
            {
              case 0:
              case 1:
              case 2: b = 249; break;
              case 3: b = 176; break;
              case 4: b = 177; break;
              case 5: b = 178; break;
            }
            if (random(2) == 0)
              f = YELLOW;
            else
              f = WHITE;
            scrbuf[(pc[g].fx+1)*2][pc[g].fy+1] = f + (LIGHTGRAY << 4);
            scrbuf[(pc[g].fx+1)*2+1][pc[g].fy+1] = b;
          }
          }
          for (b = 0;b < 36;b++)
          {
            if (shots[b].lifespan > 0 && shots[b].rd == pc[a].rd)
            {
              scrbuf[(shots[b].x+1)*2][shots[b].y+1] = shots[b].color + (LIGHTGRAY << 4);
              scrbuf[(shots[b].x+1)*2+1][shots[b].y+1] = shots[b].frames[frame];
            }
          }
          for (b = 0;b < 10;b++)
          {
            if (mon[pc[a].rd][b].hp > 0)
            {
              if (mon[pc[a].rd][b].hit == 1 || mon[a][b].hit == 2)
                scrbuf[(mon[pc[a].rd][b].x+1)*2][mon[pc[a].rd][b].y+1] = YELLOW + (BLUE << 4);
              else
              {
                if (map[pc[a].roomx][pc[a].roomy].monstertype->type == ICED)
                  scrbuf[(mon[pc[a].rd][b].x+1)*2][mon[pc[a].rd][b].y+1] = WHITE + (CYAN << 4);
                else
                  scrbuf[(mon[pc[a].rd][b].x+1)*2][mon[pc[a].rd][b].y+1] = YELLOW + (RED << 4);
              }
              scrbuf[(mon[pc[a].rd][b].x+1)*2+1][mon[pc[a].rd][b].y+1] = b+48;
            }
          }
          for (b = 0;b < 4;b++)
          {
            if (c[b] != -1 && character[c[b]].playing == 1 && pc[b].rd == pc[a].rd)
            {
              if (pc[b].hit == 1)
                f = MAGENTA;
              else
                f = BLACK;
              if (character[c[b]].dead == 0)
              {
                if (frame % 2 == 1)
                  f = DARKGRAY + (f << 4);
                else
                  f = RED + (f << 4);
              }
              else if (b == a)
              {
                if (frame % 2 == 1)
                  f = WHITE + (f << 4);
                else
                  f = YELLOW + (f << 4);
              }
              else
              {
                if (frame % 2 == 1)
                  f = LIGHTGRAY + (f << 4);
                else
                  f = BROWN + (f << 4);
              }
              switch (pc[b].facing)
              {
                case MUP: g = 24; break;
                case MDOWN: g = 25; break;
                case MRIGHT: g = 26; break;
                case MLEFT: g = 27; break;
              }
              scrbuf[(pc[b].x+1)*2][pc[b].y+1] = f;
              if (frame%2 == 1)
                scrbuf[(pc[b].x+1)*2+1][pc[b].y+1] = c[b]+48;
              else
              {
                if (character[c[b]].dead == 0)
                  scrbuf[(pc[b].x+1)*2+1][pc[b].y+1] = 'X';
                else
                  scrbuf[(pc[b].x+1)*2+1][pc[b].y+1] = g;
              }
              pc[b].hit = 0;
            }
          }
          if (pc[a].roomx == startx && pc[a].roomy == starty)
          {
            for (b = 2;b < 6;b++)
            {
              scrbuf[b*2][5] = light[frame%2][b-2][0];
              scrbuf[b*2+1][5] = light[frame%2][b-2][1];
            }
          }
          else if (pc[a].roomx == mysticx && pc[a].roomy == mysticy)
          {
            scrbuf[10][5] = random(16) + (BLACK << 4);
            scrbuf[11][5] = warp[frame];
          }
        }
        else
        {
          for (dx = 0;dx < 12;dx++)
          {
            for (dy = 0;dy < 12;dy++)
            {
              scrbuf[dx*2][dy] = DARKGRAY + (BLACK << 4);
              scrbuf[dx*2+1][dy] = 176;

            }
          }
        }
        for (dx = 0;dx < 12;dx++)
        {
          for (dy = 0;dy< 12;dy++)
          {
            textattr(scrbuf[dx*2][dy]);
            gotoxy(dx+1, dy+1);
            putch(scrbuf[dx*2+1][dy]);
          }
        }
      }
    }
    }
    for (a = 0;a < 4;a++)
    {
      for (b = 0;b < 10;b++)
      {
        if (mon[a][b].hit == 2)
          mon[a][b].hit = 0;
      }
    }
    for (a = 0;a < 36;a++)
      shots[a].lifespan--;
    window(1,1,80,25);
    snd.play();
    delay(gamespeed);
    snd.pstop();
  }
  for (a = 0;a < 4;a++)
  {
    if (c[a] != -1 && character[c[a]].playing == 1)
    {
      sellstuff(a);
      character[c[a]].playing = 0;
      players--;
      if (character[c[a]].dead == 0)
      {
        character[c[a]].dead = 1;
        killplayer(a);
      }
    }
  }
  snd.pstop(1);
}
